% get the irfs


tau=0;
nper=50;
e=ones(1,nper);
e(1)=0.95;

kout=[];
ktrapout=[];

for liq=0:1
    
k=[];
k(1)=0.1896;

ktrap=[];
ktrap(1)=k(1);

for i=2:nper

% no traps    
k(i) = traps9_irf(liq,lambda0,lambda1,lambda2,e(i-1),Exalpha,pi,beta,tau,alpha,k(i-1)) ;

% with traps
ktrap(i) = traps9_irf2(liq,lambda0,lambda1,lambda2,lambdab,xb,e(i-1),Exalpha,pi,beta,tau,alpha,ktrap(i-1)) ;

end

kout=[kout k'];
ktrapout=[ktrapout ktrap'];

end

% output
yout = kout.^alpha;
ytrapout = ktrapout.^alpha ;

hz=11;

% figure, 
%     hold all
%     plot(kout(1:hz,1),'b','LineWidth',2)
%     plot(kout(1:hz,2),'r','LineWidth',2)
%     plot(ktrapout(1:hz,2),'g','LineWidth',2)
%     box on
%     legend('Without liquidation','With liquidation','With liquidation and trap')
    
figure, 
    hold all
    plot( 0:1:hz-1, 100.*( kout(1:hz,1)./k(1) - 1 ),'b','LineWidth',2)
    plot( 0:1:hz-1, 100.*( kout(1:hz,2)./k(1) - 1 ),'r','LineWidth',2)
    plot( 0:1:hz-1, 100.*( ktrapout(1:hz,2)./k(1) - 1),'g','LineWidth',2)
    box on
    legend('Without liquidation','With liquidation','With liquidation and trap')   
    ylabel('k_t, % deviation')
    
figure, 
    hold all
    plot( 0:1:hz-1, 100.*( yout(1:hz,1)./yout(1) - 1 ),'b','LineWidth',1.5)
    plot( 0:1:hz-1, 100.*( yout(1:hz,2)./yout(1) - 1 ),'--b','LineWidth',1.5)
    plot( 0:1:hz-1, 100.*( ytrapout(1:hz,2)./yout(1) - 1),'o-r','LineWidth',1.5)
    box on
    legend('Without liquidation','With liquidation','With liquidation and credit trap')   
    ylabel('y_t, % deviation') 
    xlabel('Periods')