function out1 = traps9_irf2(liq,lambda0,lambda1,lambda2,lambdab,xb,e,Exalpha,pi,beta,tau,alpha,k)
        % CASE OF LIQUIDATION
        if liq==1
            
        ll=lambda0+lambda1.*(k./(lambda2+k));
        
            % good shock realisation:
            if e>Exalpha
        
            shk=e;
            
            % law of motion
            out1 = shk.*((pi+beta.*(1-tau).*ll)./(1+beta.*(1-tau).*ll)).*(1-alpha).*(k.^alpha) ;
        
%             % 1st deriv
%             f1 = - beta.*ll.*(1-pi) ./ (( 1 + beta.*(1-tau).*ll ).^2) ;
%             out2 = shk.*f1.*(1-alpha).*(k.^alpha);
%         
%             % 2nd deriv
%             ff1 = ((beta*ll).^2) ./ ((1 + beta.*(1-tau).*ll).^3) ;
%             out3 = -2.*shk.*ff1.*(1-pi).*(1-alpha).*(k.^alpha);
%         
            % bad shock realisation:
            else

            shk=( ( e.^alpha - (1-tau).*ll.*Exalpha)./(1-(1-tau).*ll) ).^(1/alpha);

            % check the trap condition (42)
            cond_lhs = ((1 + beta.*ll).^(1-alpha)).*(( pi + beta.*ll ).^alpha).*Exalpha ;
            
            cond_rhs = ((1 + beta.*lambdab).^(1-alpha)).*(( pi + beta.*lambdab ).^alpha).*(xb.^alpha) ;
            
            if cond_lhs >= cond_rhs
            
            % law of motion in sector a
            out1 = shk.*((pi+beta.*(1-tau).*ll)./(1+beta.*(1-tau).*ll)).*(1-alpha).*(k.^alpha) ;

            else
                
            % law of motion in sector b                
            out1 = xb.*((pi+beta.*(1-tau).*lambdab)./(1+beta.*(1-tau).*lambdab)).*(1-alpha).*(k.^alpha) ;                
            
            end
%             % 1st deriv
%             f1 = - beta.*ll.*(1-pi) ./ (( 1 + beta.*(1-tau).*ll ).^2) ;
% 
%             g1 = ll.*( Exalpha - e.^alpha )./alpha ;
%             g2 = ( e.^alpha - (1-tau).*ll.*Exalpha ).^((1-alpha)./alpha);
%             g3 = (1 - (1-tau).*ll).^((1+alpha)/alpha);
%             dg = g1.*g2./g3;
% 
%             out2 = shk.*f1.*(1-alpha).*(k.^alpha) + dg.*((pi+beta.*(1-tau).*ll)./(1+beta.*(1-tau).*ll)).*(1-alpha).*(k.^alpha);
% 
%             % 2nd deriv
%             ff1 = ((beta*ll).^2) ./ ((1 + beta.*(1-tau).*ll).^3) ;
% 
%             dg2 = dg.*(ll./alpha).*((1-alpha).*Exalpha./(g2.^(alpha/(1+alpha))) - (1+alpha).*(g3.^(alpha/(1+alpha))));
% 
%             out3 = -2.*shk.*ff1.*(1-pi).*(1-alpha).*(k.^alpha) ...
%                   + 2.*dg.*f1.*(1-alpha).*(k.^alpha) ...
%                   + dg2.*((pi+beta.*(1-tau).*ll)./(1+beta.*(1-tau).*ll)).*(1-alpha).*(k.^alpha);        
        
            end
        
        % CASE OF NO LIQUIDATION:
        else
            
            ll=lambda0+lambda1.*(k./(lambda2+k));

            shk=e;

            % law of motion
            out1 = shk.*((pi+beta.*(1-tau).*ll)./(1+beta.*(1-tau).*ll)).*(1-alpha).*(k.^alpha) ;

%             % 1st deriv
%             f1 = - beta.*ll.*(1-pi) ./ (( 1 + beta.*(1-tau).*ll ).^2) ;
%             out2 = shk.*f1.*(1-alpha).*(k.^alpha);
% 
%             % 2nd deriv
%             ff1 = ((beta*ll).^2) ./ ((1 + beta.*(1-tau).*ll).^3) ;
%             out3 = -2.*shk.*ff1.*(1-pi).*(1-alpha).*(k.^alpha);
        
        end
        
end